> For the complete documentation index, see [llms.txt](https://docs.getblock.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.getblock.io/api-reference/xrp-ledger/book_offers-xrpl.md).

# book\_offers - XRPL

This method retrieves a list of offers, also known as the order book, between two currencies.

## Parameters

| Parameter     | Type          | Required | Description             |
| ------------- | ------------- | -------- | ----------------------- |
| taker\_gets   | object        | Yes      | Currency taker receives |
| taker\_pays   | object        | Yes      | Currency taker pays     |
| ledger\_hash  | string        | No       | Ledger hash             |
| ledger\_index | string/number | No       | Ledger index            |
| limit         | number        | No       | Maximum results         |
| taker         | string        | No       | Perspective account     |

## Request Example

{% tabs %}
{% tab title="cURL" %}

```bash
curl --location --request POST 'https://go.getblock.io/<ACCESS_TOKEN>/' \
--header 'Content-Type: application/json' \
--data-raw '{
    "jsonrpc": "2.0",
    "method": "book_offers",
    "params": [{
        "taker_gets": {"currency": "XRP"},
        "taker_pays": {
            "currency": "USD",
            "issuer": "rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B"
        },
        "limit": 10
    }],
    "id": "getblock.io"
}'
```

{% endtab %}

{% tab title="JavaScript (Axios)" %}
{% code title="book\_offers.js" %}

```javascript
const axios = require('axios');

const url = 'https://go.getblock.io/<ACCESS_TOKEN>/';
const headers = {
    'Content-Type': 'application/json'
};

const payload = {
    jsonrpc: '2.0',
    method: 'book_offers',
    params: [{
        taker_gets: { currency: 'XRP' },
        taker_pays: {
            currency: 'USD',
            issuer: 'rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B'
        },
        limit: 10
    }],
    id: 'getblock.io'
};

axios.post(url, payload, { headers })
    .then(response => console.log(response.data))
    .catch(error => console.error(error));
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code title="book\_offers.py" %}

```python
import requests

url = "https://go.getblock.io/<ACCESS_TOKEN>/"
headers = {
    "Content-Type": "application/json"
}

payload = {
    "jsonrpc": "2.0",
    "method": "book_offers",
    "params": [{
        "taker_gets": {"currency": "XRP"},
        "taker_pays": {
            "currency": "USD",
            "issuer": "rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B"
        },
        "limit": 10
    }],
    "id": "getblock.io"
}

response = requests.post(url, headers=headers, json=payload)
print(response.json())
```

{% endcode %}
{% endtab %}

{% tab title="Rust" %}
{% code title="book\_offers.rs" %}

```rust
use reqwest::Client;
use serde_json::json;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let client = Client::new();
    
    let payload = json!({
        "jsonrpc": "2.0",
        "method": "book_offers",
        "params": [{
            "taker_gets": {"currency": "XRP"},
            "taker_pays": {
                "currency": "USD",
                "issuer": "rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B"
            },
            "limit": 10
        }],
        "id": "getblock.io"
    });

    let response = client
        .post("https://go.getblock.io/<ACCESS_TOKEN>/")
        .header("Content-Type", "application/json")
        .json(&payload)
        .send()
        .await?;

    let result: serde_json::Value = response.json().await?;
    println!("{:#?}", result);
    
    Ok(())
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Response Example

```json
{
    "result": {
        "ledger_current_index": 63632030,
        "offers": [
            {
                "Account": "rN7n7otQDd6FczFgLdSqtcsAUxDkw6fzRH",
                "BookDirectory": "...",
                "BookNode": "0",
                "Flags": 0,
                "OwnerNode": "0",
                "Sequence": 100,
                "TakerGets": "1000000",
                "TakerPays": {
                    "currency": "USD",
                    "issuer": "rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B",
                    "value": "1"
                }
            }
        ],
        "status": "success"
    }
}
```

## Response Parameters

| Parameter              | Type          | Description        |
| ---------------------- | ------------- | ------------------ |
| offers                 | array         | Order book entries |
| TakerGets              | object/string | Receiving amount   |
| TakerPays              | object/string | Paying amount      |
| ledger\_current\_index | integer       | current ledger     |

## Use Cases

* View order book
* Build trading UI
* Calculate exchange rates

## Error Handling

| Error Code    | Description        |
| ------------- | ------------------ |
| invalidParams | Invalid parameters |

## SDK Integration

{% tabs %}
{% tab title="xrpl.js" %}

```javascript
const xrpl = require('xrpl');

async function getOffers() {
    const client = new xrpl.Client('wss://xrplcluster.com');
    await client.connect();
    
    const response = await client.request({
        command: 'book_offers',
        taker_gets: { currency: 'XRP' },
        taker_pays: {
            currency: 'USD',
            issuer: 'rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B'
        }
    });
    
    console.log('Offers:', response.result.offers.length);
    await client.disconnect();
}

getOffers();
```

{% endtab %}

{% tab title="xrpl-py" %}

```python
from xrpl.clients import JsonRpcClient
from xrpl.models.requests import BookOffers
from xrpl.models.currencies import XRP, IssuedCurrency

client = JsonRpcClient("https://xrp.getblock.io/mainnet/")
request = BookOffers(
    taker_gets=XRP(),
    taker_pays=IssuedCurrency(currency="USD", issuer="rvYAfWj5gh67oV6fW32ZzP3Aw4Eubs59B")
)
response = client.request(request)
print(response.result)
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.getblock.io/api-reference/xrp-ledger/book_offers-xrpl.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
